View Issue Details

IDProjectCategoryView StatusLast Update
0028500Open CASCADEOCCT:Meshpublic2022-11-02 13:52
Reportermsv Assigned Tooan  
PrioritynormalSeverityminor 
Status verifiedResolutionfixed 
Product Version7.1.0 
Target Version7.7.0 
Summary0028500: Mesh - Artifact in shaded view of the shape
DescriptionDuring meshing with BRepMesh of the attached shape the algorithm reports OpenWire meshing status. This results in artifact displayed in shaded view in the form of a green line (see the picture).
Actually the faces for which the status OpenWire is reported are valid faces. It is needed to teach BRepMesh produce triangles for such faces, even if they are degenerated in a line, in order to produce conform mesh.
Steps To Reproducerestore shape_mesh_artifact.brep a
incmesh a 0.01
TagsNo tags attached.
Test case numberbugs mesh bug28500

Attached Files

  • shape_mesh_artifact.brep (60,209 bytes)
  • mesh_pb.PNG (15,383 bytes)

Relationships

related to 0022849 feedbackika Community Bad import of a STEP file (error during triangulation). 
parent of 0031043 closedoan Open CASCADE GCPnts_TangentialDeflection generates points which number is inconsistent with MinimumOfPoints parameter 

Activities

msv

2017-03-01 19:11

developer  

shape_mesh_artifact.brep (60,209 bytes)

msv

2017-03-01 19:12

developer  

mesh_pb.PNG (15,383 bytes)

oan

2017-03-02 11:18

developer   ~0064068

DC,

It would be easy to try to implement custom processing of cases consisting of two edges which ends are covered by vertex tolerances after integration of 0026106 as far it allows processing and modification of wires and particular edges.

msv

2017-03-02 12:30

developer   ~0064073

I agree.

mkv

2017-08-31 16:18

tester   ~0070125

Problem described in issue is reproduced on current state of OCCT.

git

2019-10-19 19:23

administrator   ~0088331

Branch CR28500 has been created by oan.

SHA-1: 845785da4787cc0f8781cd6c79bec110a75d7744


Detailed log of new commits:

Author: oan
Date: Sat Oct 19 19:22:38 2019 +0300

    0028500: Artifact in shaded view of the shape
    increase minimum number of discretization points by one explicitly on each iteration of model healer to cover cases degenerated to line

git

2019-10-20 00:42

administrator   ~0088339

Branch CR28500 has been updated by oan.

SHA-1: f92206a61a77ff4420d6387404a04f900e0e2779


Detailed log of new commits:

Author: oan
Date: Sun Oct 20 00:41:48 2019 +0300

    # modified test case

git

2019-10-20 00:44

administrator   ~0088340

Branch CR28500 has been updated forcibly by oan.

SHA-1: a66a5d097c396d3140e98c52bb66f047a039eeb6

git

2019-10-21 19:36

administrator   ~0088394

Branch CR28500 has been updated forcibly by oan.

SHA-1: 9dfde6c9b3b6b8605e33febf5cc14db6e9661df8

git

2019-10-22 12:06

administrator   ~0088407

Branch CR28500 has been updated by oan.

SHA-1: 18d60a72fc7b7573973c385d5df6e320cea2c3b7


Detailed log of new commits:

Author: oan
Date: Tue Oct 22 11:28:49 2019 +0300

    # updated test cases

git

2019-10-28 13:49

administrator   ~0088634

Branch CR28500 has been updated forcibly by oan.

SHA-1: af5ac75fa762e7026ee7c8e04a6a6876b9e1be63

git

2019-10-30 12:09

administrator   ~0088659

Branch CR28500_1 has been created by oan.

SHA-1: 3c7e218e18aa3c2ef01354bc61d7b0cfb47bd2a0


Detailed log of new commits:

Author: oan
Date: Wed Oct 30 12:08:19 2019 +0300

    0028500: Artifact in shaded view of the shape increase minimum number of discretization points by one explicitly on each iteration of model healer to cover cases degenerated to line

git

2019-11-07 13:03

administrator   ~0088775

Branch CR28500_1 has been updated forcibly by oan.

SHA-1: 0d5b7b80e0305729e0818a21fefe16c6c7242395

git

2022-10-18 16:00

administrator   ~0111635

Branch CR28500_2 has been created by oan.

SHA-1: 4cb307ee11440d937ee3d2bfc83f98d03b532549


Detailed log of new commits:

Author: oan
Date: Wed Oct 30 12:08:19 2019 +0300

    0028500: Artifact in shaded view of the shape increase minimum number of discretization points by one explicitly on each iteration of model healer to cover cases degenerated to line

git

2022-10-18 18:47

administrator   ~0111642

Branch CR28500_2 has been updated forcibly by oan.

SHA-1: 3cc953eabd3059cb71bc811788a1d070b04cf5ba

git

2022-10-18 19:13

administrator   ~0111643

Branch CR28500_1 has been updated forcibly by oan.

SHA-1: aa4a69a23a7a93e6a26c614b7ab761618657bc29

git

2022-10-18 19:14

administrator   ~0111644

Branch CR28500_2 has been updated forcibly by oan.

SHA-1: aa4a69a23a7a93e6a26c614b7ab761618657bc29

git

2022-10-18 19:14

administrator   ~0111645

Branch CR28500_1 has been deleted by oan.

SHA-1: aa4a69a23a7a93e6a26c614b7ab761618657bc29

git

2022-10-19 00:18

administrator   ~0111646

Branch CR28500_2 has been updated forcibly by oan.

SHA-1: 691d6870fa9994e5863eb5b58728c51d4d65d819

oan

2022-10-19 00:26

developer   ~0111648

Test reports:
http://jenkins-test-occt/view/master-CR28500_2-OAN/view/COMPARE/

To integrate:
OCCT: CR28500_2
PRODUCTS: None

msv

2022-10-19 10:49

developer   ~0111651

tests/bugs/mesh/bug28500
19: misprint "containg"

src/BRepMesh/BRepMesh_ModelHealer.cxx
Why aPointsNb is incremented regardless of its initial value? It seems it is not needed to be increased if its value is more than 2.

tests/bugs/moddata_2/bug428
Why did you change correct word "visualization" to incorrect "vizualization"?

git

2022-10-19 13:25

administrator   ~0111658

Branch CR28500_2 has been updated forcibly by oan.

SHA-1: 5d0d0a3f1cd28f9364abcb522740cc3dd0ec828c

oan

2022-10-19 13:25

developer   ~0111659

@msv,
19: misprint "containg"

Corrected

Why aPointsNb is incremented regardless of its initial value? It seems it is not needed to be increased if its value is more than 2.

You proposition is adequate, however, I suppose that there could be cases when even 3 points would not be enough.
Note that amplification of edges is an iterative process limited by 5 iterations (i.e. maximum 5 extra points). Thus, if we add the proposed limit we will not obtain more detail result, e.g. in case of almost straight BSpline curve where value of deflection is almost always a nonsence. Imagine that self-intersection at 1/4 of a curve could be resolved only if a curve contains points at range covering such self-intersection. I'm not sure that this case is common, but anyway, IMHO, it is better to have such protection than not.

Why did you change correct word "visualization" to incorrect "vizualization"? 

I didn't. This is a result of cherry pick of a draft patch that was older than change correcting the letter. Corrected.

msv

2022-10-19 14:41

developer   ~0111662

To integrate:
OCCT: CR28500_2
PRODUCTS: None

git

2022-11-02 13:52

administrator   ~0111851

Branch CR28500 has been deleted by mnt.

SHA-1: af5ac75fa762e7026ee7c8e04a6a6876b9e1be63

git

2022-11-02 13:52

administrator   ~0111852

Branch CR28500_2 has been deleted by mnt.

SHA-1: 5d0d0a3f1cd28f9364abcb522740cc3dd0ec828c

Related Changesets

occt: master f73592ed

2019-10-30 12:08:19

oan


Committer: smoskvin Details Diff
0028500: Artifact in shaded view of the shape

Increase minimum number of discretization points by one explicitly on each iteration of model healer to cover cases degenerated to line (for cases when face consists of 2 edges only).
Affected Issues
0028500
mod - src/BRepMesh/BRepMesh_CurveTessellator.cxx Diff File
mod - src/BRepMesh/BRepMesh_CurveTessellator.hxx Diff File
mod - src/BRepMesh/BRepMesh_EdgeDiscret.cxx Diff File
mod - src/BRepMesh/BRepMesh_EdgeDiscret.hxx Diff File
mod - src/BRepMesh/BRepMesh_ModelHealer.cxx Diff File
mod - tests/bugs/mesh/bug25044_12 Diff File
mod - tests/bugs/mesh/bug25044_13 Diff File
mod - tests/bugs/mesh/bug25044_60 Diff File
mod - tests/bugs/mesh/bug28500 Diff File
mod - tests/bugs/mesh/bug32692_1 Diff File
mod - tests/hlr/poly_hlr/bug23625_1 Diff File
mod - tests/hlr/poly_hlr/C3 Diff File

Issue History

Date Modified Username Field Change
2017-03-01 19:11 msv New Issue
2017-03-01 19:11 msv Assigned To => oan
2017-03-01 19:11 msv File Added: shape_mesh_artifact.brep
2017-03-01 19:12 msv File Added: mesh_pb.PNG
2017-03-02 11:18 oan Note Added: 0064068
2017-03-02 12:30 msv Note Added: 0064073
2017-07-20 12:43 oan Target Version 7.2.0 => 7.3.0
2017-08-31 16:18 mkv Test case number => bugs mesh bug28500
2017-08-31 16:18 mkv Note Added: 0070125
2018-02-25 23:12 abv Target Version 7.3.0 => 7.4.0
2019-09-06 16:16 oan Target Version 7.4.0 => 7.5.0
2019-10-07 18:59 oan Relationship added parent of 0031043
2019-10-19 19:23 git Note Added: 0088331
2019-10-20 00:42 git Note Added: 0088339
2019-10-20 00:44 git Note Added: 0088340
2019-10-21 19:36 git Note Added: 0088394
2019-10-22 12:06 git Note Added: 0088407
2019-10-28 13:49 git Note Added: 0088634
2019-10-30 12:09 git Note Added: 0088659
2019-11-07 13:03 git Note Added: 0088775
2020-08-28 15:51 oan Target Version 7.5.0 => 7.6.0
2021-08-24 00:24 kgv Summary Artifact in shaded view of the shape => Mesh - Artifact in shaded view of the shape
2021-10-07 12:12 szy Target Version 7.6.0 => 7.7.0
2022-10-18 16:00 git Note Added: 0111635
2022-10-18 18:47 git Note Added: 0111642
2022-10-18 19:13 git Note Added: 0111643
2022-10-18 19:14 git Note Added: 0111644
2022-10-18 19:14 git Note Added: 0111645
2022-10-19 00:18 git Note Added: 0111646
2022-10-19 00:26 oan Assigned To oan => msv
2022-10-19 00:26 oan Status new => resolved
2022-10-19 00:26 oan Note Added: 0111648
2022-10-19 10:49 msv Note Added: 0111651
2022-10-19 10:49 msv Assigned To msv => oan
2022-10-19 10:49 msv Status resolved => assigned
2022-10-19 13:25 git Note Added: 0111658
2022-10-19 13:25 oan Note Added: 0111659
2022-10-19 13:27 oan Assigned To oan => msv
2022-10-19 13:27 oan Status assigned => resolved
2022-10-19 13:32 oan Relationship added related to 0022849
2022-10-19 14:41 msv Assigned To msv => bugmaster
2022-10-19 14:41 msv Status resolved => reviewed
2022-10-19 14:41 msv Note Added: 0111662
2022-11-02 13:40 smoskvin Status reviewed => tested
2022-11-02 13:46 smoskvin Changeset attached => occt master f73592ed
2022-11-02 13:46 oan Assigned To bugmaster => oan
2022-11-02 13:46 oan Status tested => verified
2022-11-02 13:46 oan Resolution open => fixed
2022-11-02 13:52 git Note Added: 0111851
2022-11-02 13:52 git Note Added: 0111852